# modello per tsp
param n > 0, integer;
set V := 1..n;
param d{V,V} >= 0;
param cap{V,V} >= 0;

param s >= 0, integer;
param t >= 0, integer;

param numerocicli >= 0, integer, default 0;
set ciclo{1..numerocicli};
var x{V,V} binary;
var f{i in V, j in V} >= 0, <= cap[i,j];
var phi;

minimize costociclo : sum{i in V, j in V : i != j} d[i,j]*x[i,j];
subject to successore {i in V} : sum{j in V : i != j} x[i,j] = 1;
subject to predecessore {j in V} : sum{i in V : i != j} x[i,j] = 1;
subject to nocicli {k in 1..numerocicli} :
sum{i in ciclo[k], j in V diff ciclo[k]} x[i,j] >= 1;


maximize flusso: phi;

subject to conservazione {i in V : i != s and i != t}:
sum{j in V:j<>i} f[i,j] = sum{j in V:j<>i} f[j,i];

subject to conservazioneS:
sum{i in V} f[s,i] - sum{i in V} f[i,s] -phi  = 0;
subject to conservazioneT:
sum{i in V} f[t,i] - sum{ i in V} f[i,t] +phi  = 0;


